#
# Copyright 2016 The BigDL Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#


from ..metric import ONNXRuntimeINCMetic
import tensorflow as tf


class KerasONNXRuntimeINCMetic(ONNXRuntimeINCMetic):
    '''
    ONNXRuntime will use numpy as data type.
    ONNXRuntime quantization in tensorflow will use tf.keras.metrics.Metric
    '''

    def stack(self, preds, labels):
        # calculate accuracy
        preds, labels = super().stack(preds, labels)
        preds = tf.convert_to_tensor(preds)
        labels = tf.convert_to_tensor(labels)
        return preds, labels

    def to_scalar(self, tensor):
        return float(tensor)
